diff a/src/java.base/share/classes/module-info.java b/src/java.base/share/classes/module-info.java
--- a/src/java.base/share/classes/module-info.java
+++ b/src/java.base/share/classes/module-info.java
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 2014, 2023, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2014, 2024, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.  Oracle designates this
@@ -88,10 +88,18 @@
     exports java.lang.foreign;
     exports java.lang.invoke;
     exports java.lang.module;
     exports java.lang.ref;
     exports java.lang.reflect;
+    exports java.lang.reflect.code;
+    exports java.lang.reflect.code.analysis;
+    exports java.lang.reflect.code.bytecode;
+    exports java.lang.reflect.code.interpreter;
+    exports java.lang.reflect.code.op;
+    exports java.lang.reflect.code.parser;
+    exports java.lang.reflect.code.type;
+    exports java.lang.reflect.code.writer;
     exports java.lang.runtime;
     exports java.math;
     exports java.net;
     exports java.net.spi;
     exports java.nio;
@@ -372,10 +380,11 @@
         java.desktop,
         java.logging,
         java.prefs;
     exports sun.util.resources to
         jdk.localedata;
+    exports java.lang.reflect.code.type.impl;
 
     // the service types defined by the APIs in this module
 
     uses java.lang.System.LoggerFinder;
     uses java.net.ContentHandlerFactory;
